var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Animation</title>\n\
   <meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Animation</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"animation\"></a></div>\n\
<div class=\'section\'><a id=\"getting-and-setting-the-frame-range\"></a><h2 id=\"getting-and-setting-the-frame-range\">Getting and setting the frame range</h2></div>\n\
<p>When you get or set time intervals via the API, intervals are represented not as the number of frames, but instead as the number of frames multiplied by the number of ticks. Each frame contains 160 ticks. Therefore, intervals are represented as <em>number of frames x 160</em>.</p>\n\
<p>Therefore, when you get or print values, you need to divide the interval by 160 to obtain the actual frame number. Likewise for setting values.</p>\n\
<p>Use <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Animation.GetAnimRange()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_animation.html#acea9b9f4d693e19bb200c0fcfc57a69d&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Animation.GetAnimRange()</a></span> to get your animation range. The default value is 100x160.</p>\n\
<p>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"demoAnimation.py\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/demo_animation_8py-example.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">demoAnimation.py</a></span> example defines a <span class=\'code\'>PrintInterval</span> method that divides intervals by 160 and prints the results in terms of frames. In this example, <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Animation.GetAnimRange()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_animation.html#acea9b9f4d693e19bb200c0fcfc57a69d&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Animation.GetAnimRange()</a></span> is used to obtain the default frame range, then the <span class=\'code\'>PrintInterval</span> method is called so that the frame range can be printed out in a user friendly way, in terms of frames:</p>\n\
<div class=\'codeBlock\'><pre>anim = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Animation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_animation.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Animation</a>\n\
PrintInterval(anim.GetAnimRange())\n\
</pre></div><div class=\'section\'><a id=\"creating-intervals\"></a><h2 id=\"creating-intervals\">Creating intervals</h2></div>\n\
<p>There are two constructors for the interval class:</p>\n\
<ul>\n\
<li><span class=\'code\'>Interval()</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Interval\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_interval.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Interval</a>(TimeValue start, TimeValue end)</span></li>\n\
</ul>\n\
<p>When calling the second constructor, remember to multiply the number of frames by 160 ticks again. You can then set the frame range using <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Animation.SetRange()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_animation.html#ae296faa5b3e5b418bcef6cdd3db6e2ce&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Animation.SetRange()</a></span>:</p>\n\
<div class=\'codeBlock\'><pre>newFrames = 200 * 160\n\
newRange = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Interval\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_interval.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Interval</a>(0,newFrames)\n\
anim.SetRange(newRange)\n\
</pre></div><div class=\'section\'><a id=\"setting-the-keys-to-your-animation\"></a><h2 id=\"setting-the-keys-to-your-animation\">Setting the keys to your animation</h2></div>\n\
<p>To enable the Auto Key button, call <span class=\'code\'>Animation.SetAnimateButtonState(True)</span>.</p>\n\
<p>To set each keyframe, set its time, and move your object. Remember to multiply the frame number by the number of ticks. The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"demoAnimation.py\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/demo_animation_8py-example.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">demoAnimation.py</a></span> example demonstrates these steps as follows:</p>\n\
<div class=\'codeBlock\'><pre>doRedraw = True\n\
\n\
# Advance the time slider to frame 30\n\
anim.SetTime(30*ticks,doRedraw)\n\
\n\
# Move the sphere; this creates a keyframe\n\
sphere.Move( <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Point3\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_point3.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Point3</a>(50,0,0) )\n\
</pre></div><p>Turn off the button after setting your keys by calling: <span class=\'code\'>Animation.SetAnimateButtonState(False)</span>.</p>\n\
<div class=\'section\'><a id=\"playing-back-the-animation\"></a><h2 id=\"playing-back-the-animation\">Playing back the animation</h2></div>\n\
<p>To playback an animation, call <span class=\'code\'>Animation.StartPlayback(int selOnly)</span>. There are two versions of this method; call the version that takes an integer as input.</p>\n\
<p>You can set whether or not to play the animation as a loop by calling: <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Animation.SetPlaybackLoop()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_animation.html#a6eb8205f5e1afc3170ce3d100f10939b&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Animation.SetPlaybackLoop()</a></span>.</p>\n\
<p>To rewind back to the beginning of the time slider, for example, so that you can play the animation a second time, call: <span class=\'code\'>Animation.SetTime(0, True)</span>. An example is as follows:</p>\n\
<div class=\'codeBlock\'><pre>anim = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Animation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_animation.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Animation</a>\n\
    \n\
anim.SetPlaybackLoop(False)\n\
OldStyle = 1  \n\
# Important: provide an integer value as input to StartPlayback\n\
anim.StartPlayback(OldStyle)\n\
    \n\
anim.SetTime(0*ticks,doRedraw)\n\
anim.StartPlayback(OldStyle)\n\
</pre></div><div class=\'section\'><a id=\"playback-speed\"></a><h2 id=\"playback-speed\">Playback speed</h2></div>\n\
<p><span class=\'code\'>Animation.SetPlaybackSpeed(int s)</span> takes only five discrete integers as input. To avoid guessing the previously undocumented values, the class <span class=\'code\'>PlaybackSpeed</span> was written in the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"demoAnimation.py\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/demo_animation_8py-example.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">demoAnimation.py</a></span> example. This class defines acceptable values that can be passed to <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Animation.SetPlaybackSpeed()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_animation.html#adb7d8599d9f6a1367a2c859a61f9af5f&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Animation.SetPlaybackSpeed()</a></span>. Therefore, to set your speed, you must first refer to the dictionary for the corresponding integer value for your desired playback speed before calling this method.</p>\n\
<p>For example:</p>\n\
<div class=\'codeBlock\'><pre>anim.SetPlaybackSpeed(PlaybackSpeed.X4)\n\
</pre></div><p>This command calls the previously defined <span class=\'code\'>PlaybackSpeed</span> class to obtain the integer equivalent for the quadruple time playback speed (X4), then passes the integer to <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Animation.SetPlaybackSpeed()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_animation.html#adb7d8599d9f6a1367a2c859a61f9af5f&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Animation.SetPlaybackSpeed()</a></span>.</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";