var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Creating actions and menus</title>\n\
   <meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Creating actions and menus</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"creating-actions-and-menus\"></a></div>\n\
<div class=\'section\'><a id=\"creating-an-action\"></a><h2 id=\"creating-an-action\">Creating an action</h2></div>\n\
<p>You can create an action to customize the user interface, such as the 3ds main menu or toolbars. Use the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ActionFactory.Create()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_extend_1_1_action_factory.html#ae002a80a91b6eea670e5ebb26f5ef9dc&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ActionFactory.Create()</a></span> method to create your action. You can customize the menu text, button text, description text, visibility and so forth for your action. An <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ActionItem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_action_item.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ActionItem</a></span> is created. To execute your action, use the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ActionItem.Execute()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_action_item.html#a14a8777b65486d2c71cedf4345fa4100&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ActionItem.Execute()</a></span> method, for example, as follows: <sub>~</sub> import MaxPlus</p>\n\
<p>def doSomething(): print &quot;I sleep all night and I work all day!&quot;</p>\n\
<p>action = MaxPlus.ActionFactory.Create(&#39;Do something&#39;, &#39;Python demo&#39;, doSomething) action.Execute() <sub>~</sub></p>\n\
<p>See <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"demoActionFactory.py\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/demo_action_factory_8py-example.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">demoActionFactory.py</a></span> for an example of creating an action.</p>\n\
<div class=\'section\'><a id=\"creating-a-menu\"></a><h2 id=\"creating-a-menu\">Creating a menu</h2></div>\n\
<p>The process of creating a menu can be outlined as follows:</p>\n\
<ol>\n\
<li><p>Create your action as follows: action = MaxPlus.ActionFactory.Create(&#39;Do something&#39;, &#39;Python demos&#39;, doSomething)</p></li>\n\
<li><p>Create your <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MenuBuilder\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_menu_builder.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MenuBuilder</a></span>: mb = MaxPlus.MenuBuilder(MenuName)</p></li>\n\
<li><p>Use the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MenuBuilder\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_menu_builder.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MenuBuilder</a></span> methods to add your action and a separator: mb.AddItem(action) mb.AddSeparator()</p></li>\n\
<li><p>Use the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MenuBuilder.Create()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_menu_builder.html#a63a35cb70e7a6f5260635826f653aef4&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MenuBuilder.Create()</a></span> method to create your menu:</p>\n\
<div class=\'codeBlock\'><pre>menu = mb.Create(<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.MenuManager.GetMainMenu\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_menu_manager.html#a5af76a9f189287ad1d8934c9e6341ada&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.MenuManager.GetMainMenu</a>())\n\
</pre></div><p>A <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Menu\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_menu.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Menu</a></span> is created.</p></li>\n\
</ol>\n\
<p>See <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"demoMenu.py\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/demo_menu_8py-example.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">demoMenu.py</a></span> for an example of how to create a new menu &#39;Test&#39; and unregister and remove it.</p>\n\
<p>This example first removes any previously created menus named &#39;Test&#39;, then prints out a list of all menu items in 3dsMax. It then creates an action and a new menu, and prints out again a list of all menu items. You can see from the list that a new &#39;Test&#39; menu has been created.</p>\n\
<p>The example then unregisters the newly created menu and removes it, and prints out a list of all menu items again. You can see from the list that the menu has been successfully removed.</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";