var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Creating and assigning a new material</title>\n\
   <meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Creating and assigning a new material</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"creating-and-assigning-a-new-material\"></a></div>\n\
<div class=\'section\'><a id=\"creating-a-default-material\"></a><h2 id=\"creating-a-default-material\">Creating a default material</h2></div>\n\
<p>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Factory\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Factory</a></span> class allows you to create a new default material as follows:</p>\n\
<div class=\'codeBlock\'><pre>m = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateDefaultStdMat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a419e1d850190ad66ccf4990a77bfcb6f&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Factory.CreateDefaultStdMat</a>()\n\
<blockquote>\n\
</blockquote></pre></div><p><strong>Tip:</strong> After creating your material <span class=\'code\'>m</span>, you can use <span class=\'code\'>help(type(m))</span> to obtain the list of attributes that you can set when creating a new standard default material.</p>\n\
\n\
<div class=\'section\'><a id=\"setting-its-attributes\"></a><h2 id=\"setting-its-attributes\">Setting its attributes</h2></div>\n\
<p>You can then set your attributes, for example:</p>\n\
<div class=\'codeBlock\'><pre>m.Diffuse = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Color\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_color.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Color</a>(0, 0, 1)\n\
m.Specular = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Color\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_color.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Color</a>(1, 1, 1)\n\
...\n\
</pre></div><div class=\'section\'><a id=\"assigning-a-material\"></a><h2 id=\"assigning-a-material\">Assigning a material</h2></div>\n\
<p>You can then assign it to the node of the object as follows:</p>\n\
<div class=\'codeBlock\'><pre>node.Material = m\n\
</pre></div><p>See <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"demoApplyMaterial.py\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/demo_apply_material_8py-example.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">demoApplyMaterial.py</a></span> for an example of how to create and assign a new standard default material.</p>\n\
<div class=\'section\'><a id=\"creating-a-material-using-its-classid\"></a><h2 id=\"creating-a-material-using-its-classid\">Creating a material using its ClassId</h2></div>\n\
<p>The example <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"demoMaterials.py\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/demo_materials_8py-example.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">demoMaterials.py</a></span> demonstrates how to create materials using their ClassIds and SuperClassIds.</p>\n\
<p>The example iterates through the list of API classes, and for each of those that are applicable to materials, it provides its SuperClassId and ClassId to create an <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Animatable\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_animatable.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Animatable</a></span>. It then casts it from an <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Animatable\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_animatable.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Animatable</a></span> to a <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Mtl\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_mtl.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Mtl</a></span>. A list of materials is created:</p>\n\
<div class=\'codeBlock\'><pre>for cd in <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.PluginManager.GetClassList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_plugin_manager.html#a349fff6c460e5c691f882adadf383ce1&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.PluginManager.GetClassList</a>().Classes:\n\
    if cd.SuperClassId == sid:\n\
        anim = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateAnimatable\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a2ab30f5c7691266014084e539d8ea874&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Factory.CreateAnimatable</a>(sid, cd.ClassId, False)\n\
        if anim:\n\
            inst = cls._CastFrom(anim)\n\
            if inst:\n\
                yield inst\n\
</pre></div><p>The example iterates through each of the created materials; then, for each material, creates a corresponding teapot and assigns the material to the teapot via <span class=\'code\'>INode.Material</span>.</p>\n\
<p>For each material, a text &#39;label&#39; is created and drawn beside the teapot in the viewport to identify its material:</p>\n\
<div class=\'codeBlock\'><pre>def CreateText(x,y, quat, message):\n\
    tex = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateShapeObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#ae7111496ef1c58bfaaff3ad17c8b4f94&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Factory.CreateShapeObject</a>(MaxPlus.ClassIds.text)\n\
    tex.ParameterBlock.size.Value = 10.0\n\
    tex.ParameterBlock.text.Value = message\n\
    node = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a5db9618585b8541c4f22a66190a3056f&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Factory.CreateNode</a>(tex)\n\
    node.Position = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Point3\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_point3.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Point3</a>(x, y,0)\n\
    node.SetLocalRotation( quat )\n\
    node.WireColor = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Color\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_color.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Color</a>(1.0,0.5,1.0)\n\
</pre></div><p>It also enumerates across each of the material parameters and prints them out, as well as prints out the material name and class:</p>\n\
<div class=\'codeBlock\'><pre>def PrintMaterialProperties(material_instance):\n\
    print &quot;[%s] %s&quot; % (material_instance.GetClassName(), material_instance.GetName())\n\
    for p in material_instance.ParameterBlock.Parameters:\n\
        print &quot;\\t&quot; + p.Name + &quot; = &quot; + str(p.Value)\n\
<blockquote>\n\
</blockquote></pre></div><p><strong>Tip:</strong> You can also create a new material using its ClassId by calling <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Factory.CreateMaterial()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a68d623b321702ec0ea5031848405cc8c&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Factory.CreateMaterial()</a></span>.</p>\n\
\n\
<div class=\'section\'><a id=\"opening-and-updating-the-material-editor\"></a><h2 id=\"opening-and-updating-the-material-editor\">Opening and updating the Material Editor</h2></div>\n\
<p>To open the Material Editor, call <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MaterialEditor.OpenMtlDlg()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_material_editor.html#a43d1ea216dedc3e657d5819d1be7bad4&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaterialEditor.OpenMtlDlg()</a></span>. It accepts a parameter that determines which material editor to open: the basic/legacy Material Editor or the advanced/schematic Material Editor. For convenience, the example provides a <span class=\'code\'>MtlDlgMode</span> class that lists the acceptable values that can be passed to <span class=\'code\'>OpenMtlDlg</span> :</p>\n\
<div class=\'codeBlock\'><pre><a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.MaterialEditor.OpenMtlDlg\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_material_editor.html#a43d1ea216dedc3e657d5819d1be7bad4&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.MaterialEditor.OpenMtlDlg</a>(MtlDlgMode.basic)\n\
</pre></div><p>When iterating through the created materials, the example also adds each of the materials to the Material Editor using one of two methods:</p>\n\
<div class=\'codeBlock\'><pre><a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.MaterialManager.PutMtlToMtlEditor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_material_manager.html#a8dd2047346e19d23a9796a145c3fec20&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.MaterialManager.PutMtlToMtlEditor</a>(m,index)\n\
<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.MaterialEditor.SetSlot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_material_editor.html#a6b58e7f58a653fcaeff5383ec4be0ea0&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.MaterialEditor.SetSlot</a>(index,m)\n\
</pre></div><p>To change the active, selected slot in the Material Editor, call the following. This is the equivalent of selecting a material slot with your mouse:</p>\n\
<div class=\'codeBlock\'><pre><a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.MaterialEditor.SetActiveSlot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_material_editor.html#af66eeb5698bbbefed366ec8482058e16&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.MaterialEditor.SetActiveSlot</a>(index)\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";