var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Obtaining the list of plug-ins</title>\n\
   <meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Obtaining the list of plug-ins</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"obtaining-the-list-of-plug-ins\"></a></div>\n\
<p>The example <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"demoOutputPluginClasses.py\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/demo_output_plugin_classes_8py-example.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">demoOutputPluginClasses.py</a></span> demonstrates how to use <span class=\'code\'>PluginManager.PluginDlls</span> to obtain a list of plug-in dlls that are loaded. For each dll, you can obtain information such as its description, file path, the number of classes that it includes, as well as enumerate across the list of classes.</p>\n\
<div class=\'codeBlock\'><pre>pluginsDlls = MaxPlus.PluginManager.PluginDlls\n\
print &quot;Total PluginDlls: {0}\\n&quot;.format(<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.PluginManager.GetNumPluginDlls\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_plugin_manager.html#ad4adce28a9a3cd0bc1efe07ed4685694&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.PluginManager.GetNumPluginDlls</a>())\n\
for pd in pluginsDlls:\n\
    print &quot;PluginDll:&quot;, pd.FilePath \n\
    print &quot;Description:&quot;, pd.Description\n\
    print &quot;Loaded:&quot;, pd.Loaded\n\
    print &quot;NumClasses:&quot;, pd.NumClasses\n\
    for cd in pd.Classes:\n\
        if cd:\n\
            print &quot;  &quot;, cd.GetClassName()\n\
</pre></div><p>You can enumerate across the list of classes and print out the list of class names.</p>\n\
<div class=\'codeBlock\'><pre>for cd in pd.Classes:\n\
    if cd:\n\
        print &quot;  &quot;, cd.GetClassName()\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";