var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Rendering</title>\n\
   <meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Rendering</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"rendering\"></a></div>\n\
<p>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"RenderSettings\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_render_settings.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">RenderSettings</a></span> class includes methods that allow you to set all common render settings, such as: the height and width of your render, your output file, pre/post render scripts, and so forth. These settings correspond directly to settings found on the Common tab in the Render Scene Dialog.</p>\n\
<p>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"RenderExecute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_render_execute.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">RenderExecute</a></span> class includes the <span class=\'code\'>QuickRender</span> method that allows you to execute your render.</p>\n\
<p>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ViewportManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_viewport_manager.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ViewportManager</a></span> class allows you to iterate through the viewports and perform tasks such as maximize the viewport, set a viewport as active, zoom out of the viewport, and so forth. See <a href=\'rendering.html#working-with-the-viewport\' title=\'\'>Working with the viewport</a> below for more information.</p>\n\
<div class=\'section\'><a id=\"to-execute-your-render\"></a><h2 id=\"to-execute-your-render\">To execute your render</h2></div>\n\
<p>To execute your render, use <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"RenderExecute.QuickRender()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_render_execute.html#ae48920cc3c1c8bca62cabaa3beab9560&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">RenderExecute.QuickRender()</a></span>:</p>\n\
<div class=\'codeBlock\'><pre><a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.RenderExecute.QuickRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_render_execute.html#ae48920cc3c1c8bca62cabaa3beab9560&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.RenderExecute.QuickRender</a>()\n\
</pre></div><div class=\'section\'><a id=\"rendering-to-an-output-file\"></a><h2 id=\"rendering-to-an-output-file\">Rendering to an output file</h2></div>\n\
<p>To set an output file to which your render is saved, use the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"RenderSettings.SetOutputFile()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_render_settings.html#a8f475a6ba19ef503c8c5e4ebfcb28060&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">RenderSettings.SetOutputFile()</a></span> and <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"RenderSettings.SetSaveFile()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_render_settings.html#a61fec7f41011b2b6b311c1995d1d4a41&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">RenderSettings.SetSaveFile()</a></span> methods as follows:</p>\n\
<div class=\'codeBlock\'><pre>render = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.RenderSettings\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_render_settings.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.RenderSettings</a>\n\
render.SetOutputFile(<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.PathManager.GetTempDir\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_path_manager.html#a018f5e645b8969054efc29a9f4559fc6&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.PathManager.GetTempDir</a>() + r&quot;\\testRender.jpg&quot;)\n\
render.SetSaveFile(True)\n\
</pre></div><div class=\'section\'><a id=\"set-the-width-and-height-of-your-render-output\"></a><h2 id=\"set-the-width-and-height-of-your-render-output\">Set the width and height of your render output</h2></div>\n\
<p>To set the width and height of your render, use the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"RenderSettings.SetWidth()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_render_settings.html#aa18b1e356eb1c846b149f88e50c86aa6&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">RenderSettings.SetWidth()</a></span> and <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"RenderSettings.SetHeight()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_render_settings.html#abf18ced2502636c40df5ea3590de8dd7&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">RenderSettings.SetHeight()</a></span> methods as follows:</p>\n\
<div class=\'codeBlock\'><pre>render.SetWidth(640)\n\
render.SetHeight(480)\n\
</pre></div><div class=\'section\'><a id=\"using-pre-and-post-render-scripts\"></a><h2 id=\"using-pre-and-post-render-scripts\">Using pre and post render scripts</h2></div>\n\
<p>You can also set up pre and post render scripts as follows:</p>\n\
<div class=\'codeBlock\'><pre>render.SetPreScriptFile(<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.PathManager.GetScriptsDir\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_path_manager.html#a59f20c4e493adaed0f36b213cd17fcf0&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.PathManager.GetScriptsDir</a>() + r&quot;\\Your_preRender_Script.ms&quot;)\n\
render.SetPostScriptFile(<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.PathManager.GetScriptsDir\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_path_manager.html#a59f20c4e493adaed0f36b213cd17fcf0&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.PathManager.GetScriptsDir</a>() + r&quot;\\Your_postRender_Script.ms&quot;)\n\
render.SetUsePreScript(True)\n\
render.SetLocalPreScript(True)\n\
render.SetUsePostScript(True) \n\
</pre></div><div class=\'section\'><a id=\"setting-global-options\"></a><h2 id=\"setting-global-options\">Setting global options</h2></div>\n\
<p>You can also set other global options such as: whether or not to perform render effects, whether to render atmospheric effects, whether to render hidden objects and so forth. For example, you can choose to render hidden objects using the following:</p>\n\
<div class=\'codeBlock\'><pre>render.SetHidden(1)\n\
</pre></div><div class=\'section\'><a id=\"working-with-the-viewport\"></a><h2 id=\"working-with-the-viewport\">Working with the viewport</h2></div>\n\
<div class=\'section\'><a id=\"view-types\"></a><h3 id=\"view-types\">View types</h3></div>\n\
<p>The example <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"demoRender.py\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/demo_render_8py-example.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">demoRender.py</a></span> defines a <span class=\'code\'>ViewType</span> class that is a dictionary with entries for all the available view types, and lists the numerical values for each view type and its corresponding string representation.</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Viewport.GetViewType()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_viewport.html#a69b8ca7502c9378cf240b1ec09cbd4e1&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Viewport.GetViewType()</a></span> obtains the view type for the viewport.</p>\n\
<div class=\'section\'><a id=\"maximizing-a-viewport-or-zooming-out-of-a-viewport\"></a><h3 id=\"maximizing-a-viewport-or-zooming-out-of-a-viewport\">Maximizing a viewport or zooming out of a viewport</h3></div>\n\
<p>To zoom out to view all geometry in all viewports, use the method: <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ViewportManager.ViewportZoomExtents()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_viewport_manager.html#a90cc4f3b045e59b78ec572e32c6f21b3&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ViewportManager.ViewportZoomExtents()</a></span>.</p>\n\
<p>To maximize a viewport, use <span class=\'code\'>ViewportManager.SetViewportMax(True)</span>.</p>\n\
<div class=\'section\'><a id=\"to-iterate-through-the-list-of-viewports\"></a><h3 id=\"to-iterate-through-the-list-of-viewports\">To iterate through the list of viewports</h3></div>\n\
<p>Enumerate across <span class=\'code\'>ViewportManager.Viewports</span> to access each of the viewports.</p>\n\
<blockquote>\n\
<p><strong>Note:</strong> <span class=\'code\'>ViewportManager.Viewports</span> is a generator and not a list or tuple; therefore, you cannot call <span class=\'code\'>len(ViewportManager.Viewports)</span>.</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"example\"></a><h3 id=\"example\">Example</h3></div>\n\
<p>The example <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"demoRender.py\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/demo_render_8py-example.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">demoRender.py</a></span> iterates through each of the viewports, and prints out the view type for each viewport in the workspace (in both numerical and string representation formats).</p>\n\
<div class=\'codeBlock\'><pre>for view in MaxPlus.ViewportManager.Viewports:\n\
    viewType = view.GetViewType()\n\
    print &quot;%d - %s - %s (%d)&quot; % (index, <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.ViewportManager.getViewportLabel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_viewport_manager.html#a1bcb144b69ec279d35c867fd0a4711f8&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.ViewportManager.getViewportLabel</a>(index), ViewType.GetKey(viewType), viewType)\n\
<blockquote>\n\
</blockquote></pre></div><p><strong>Note:</strong> It calls the previously defined <span class=\'code\'>ViewType.GetKey()</span> method to obtain the string representation for the view type.</p>\n\
\n\
<p>It then finds the first viewport with a perspective view and sets it as the active viewport, and maximizes it.</p>\n\
<div class=\'codeBlock\'><pre><a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.ViewportManager.SetActiveViewport\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_viewport_manager.html#ab014561afe6e7c1b5663c7ab6d236936&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.ViewportManager.SetActiveViewport</a>(perspIndex)\n\
<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.ViewportManager.SetViewportMax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_viewport_manager.html#af64ee09a9aa73906c4ce9bfb79a99168&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.ViewportManager.SetViewportMax</a>(True)\n\
</pre></div><p>It then sets the output file, enables saving and renders the scene.</p>\n\
<div class=\'codeBlock\'><pre>render.SetOutputFile( outputPath )\n\
render.SetSaveFile( True )\n\
<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.RenderExecute.QuickRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_render_execute.html#ae48920cc3c1c8bca62cabaa3beab9560&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.RenderExecute.QuickRender</a>()\n\
</pre></div><div class=\'section\'><a id=\"rendering-a-range-of-frames-and-saving-to-a-bitmap\"></a><h2 id=\"rendering-a-range-of-frames-and-saving-to-a-bitmap\">Rendering a range of frames and saving to a bitmap</h2></div>\n\
<p>For information on how to create a bitmap, see <a href=\"#!/url=./developer/maxplus_python_api_introduction/creating_a_bitmap.html\">Creating a bitmap</a>.</p>\n\
<p>After you have created a bitmap as follows, you can follow the directions below to render a range of frames and write the bitmap to an image file.</p>\n\
<div class=\'codeBlock\'><pre>import MaxPlus\n\
# Create a bitmap\n\
rendbm = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateBitmap\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a07ee5f23ef113ffd43794d70546ba7c2&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Factory.CreateBitmap</a>()\n\
\n\
# First allocate some storage. This is where the type of bitmap is determined. \n\
BMM_TRUE_64 = 7\n\
storage = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateStorage\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#af4f1df3ba6f8da558b15dc4ede6e9491&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Factory.CreateStorage</a>(BMM_TRUE_64)\n\
\n\
# Now we can get the bitmap info\n\
info = storage.GetBitmapInfo()\n\
\n\
# Set some common properties on the bitmap\n\
info.SetWidth(640)\n\
info.SetHeight(480)\n\
\n\
# Allocate storage for writing to the bitmap\n\
storage.Allocate(info, 2)\n\
\n\
# Set the storage on the bitmap\n\
rendbm.SetStorage(storage)\n\
\n\
# Set the bitmap output base file name\n\
info.SetName(<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.PathManager.GetRenderOutputDir\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_path_manager.html#a190d49f8c48aa8f6a5433cc9d71124c3&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.PathManager.GetRenderOutputDir</a>() + r&#39;\\FramesRender.tga&#39;)\n\
print info.GetName()\n\
\n\
# Display the bitmap\n\
rendbm.Display()\n\
</pre></div><div class=\'section\'><a id=\"setting-up-the-renderer-for-rendering\"></a><h3 id=\"setting-up-the-renderer-for-rendering\">Setting up the renderer for rendering</h3></div>\n\
<p>Call <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ViewportManager.GetActiveViewport()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_viewport_manager.html#a5c988065046ae8c23f886d896630a0f7&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ViewportManager.GetActiveViewport()</a></span> to get the active viewport, then pass it as a parameter to <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"RenderExecute.Open()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_render_execute.html#a0da2645847a448b65fb6fae58753302a&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">RenderExecute.Open()</a></span>. <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"RenderExecute.Open()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_render_execute.html#a0da2645847a448b65fb6fae58753302a&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">RenderExecute.Open()</a></span> performs all the setup on the renderer instance that is required before rendering a set of frames.</p>\n\
<div class=\'codeBlock\'><pre>view = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.ViewportManager.GetActiveViewport\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_viewport_manager.html#a5c988065046ae8c23f886d896630a0f7&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.ViewportManager.GetActiveViewport</a>()\n\
<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.RenderExecute.Open\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_render_execute.html#a0da2645847a448b65fb6fae58753302a&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.RenderExecute.Open</a>(view, MaxPlus.RendType.Normal, rendbm.GetWidth(), rendbm.GetHeight())\n\
</pre></div><div class=\'section\'><a id=\"preparing-the-bitmap-for-writing-to-an-image-file\"></a><h3 id=\"preparing-the-bitmap-for-writing-to-an-image-file\">Preparing the bitmap for writing to an image file</h3></div>\n\
<p>Call <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Bitmap.OpenOutput()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_bitmap.html#ae6902570d04b450bff1d434f5c49472c&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Bitmap.OpenOutput()</a></span> to prepare the bitmap for writing to the image file.</p>\n\
<div class=\'codeBlock\'><pre>rendbm.OpenOutput(info)\n\
</pre></div><div class=\'section\'><a id=\"rendering-a-range-of-frames-and-writing-the-bitmap-to-an-image-file\"></a><h3 id=\"rendering-a-range-of-frames-and-writing-the-bitmap-to-an-image-file\">Rendering a range of frames and writing the bitmap to an image file</h3></div>\n\
<p>To render a range of frames, set up a <span class=\'code\'>for</span> loop, and call <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"RenderExecute.RenderFrame()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_render_execute.html#a15f44bc4571dbdab01a5f5a95e533813&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">RenderExecute.RenderFrame()</a></span> and pass the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Bitmap\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_bitmap.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Bitmap</a></span> and (frame number * 160) as the input parameters. You must multiply the frame number by 160 because each frame contains 160 ticks.</p>\n\
<p>Call <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Bitmap.Write()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_bitmap.html#af72e5122888132dd3d110c3c3ebb6705&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Bitmap.Write()</a></span> to write the bitmap to the image file. The second argument is converted to a string and appended to the bitmap output base file name; for example, if the base file name is <span class=\'code\'>FramesRender.tga</span>, and the frame is 20, then the image file name will be: <span class=\'code\'>FramesRender0020.tga</span>.</p>\n\
<div class=\'codeBlock\'><pre>for frame in range(0, 100, 20):\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.RenderExecute.RenderFrame\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_render_execute.html#a15f44bc4571dbdab01a5f5a95e533813&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.RenderExecute.RenderFrame</a>(rendbm, frame*160)\n\
    rendbm.Write(info, frame)\n\
</pre></div><div class=\'section\'><a id=\"closing-the-renderer-and-completing-writing-to-the-image-file\"></a><h3 id=\"closing-the-renderer-and-completing-writing-to-the-image-file\">Closing the renderer and completing writing to the image file</h3></div>\n\
<p>Call <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"RenderExecute.CloseCurrent()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_render_execute.html#a0ff5c825b24de2e99042e1f014b0fa7b&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">RenderExecute.CloseCurrent()</a></span> to close the renderer instance and free the memory allocated during <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"RenderExecute.Open()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_render_execute.html#a0da2645847a448b65fb6fae58753302a&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">RenderExecute.Open()</a></span>.</p>\n\
<p>Call <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Bitmap.Close()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_bitmap.html#a386ccd984f92babd18475d91fd92ce0b&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Bitmap.Close()</a></span> to tell the bitmap that it has completed writing to the image file.</p>\n\
<div class=\'codeBlock\'><pre><a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.RenderExecute.CloseCurrent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_render_execute.html#a0ff5c825b24de2e99042e1f014b0fa7b&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.RenderExecute.CloseCurrent</a>()\n\
rendbm.Close(info)\n\
</pre></div><div class=\'section\'><a id=\"viewing-the-render-result\"></a><h3 id=\"viewing-the-render-result\">Viewing the render result</h3></div>\n\
<p>Your render results are displayed in the Rendered Frame Window, and in addition, they are saved to the location you specified when calling <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"BitmapInfo.SetName()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_bitmap_info.html#ae7164557284c72a8f6da140cc32df8df&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">BitmapInfo.SetName()</a></span>. In this example, 5 frames are rendered (0, 20, 40, 60, 80, as determined by the <span class=\'code\'>for</span> loop), and each output file name has its frame number attached (for example <span class=\'code\'>FramesRender0020.tga</span>).</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";