var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Saving the active viewport graphics window as a bitmap</title>\n\
   <meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Saving the active viewport graphics window as a bitmap</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"saving-the-active-viewport-graphics-window-as-a-bitmap\"></a></div>\n\
<p>You can obtain the active viewport&#39;s graphics window image as a bitmap. The size of the bitmap is the same as the size of the viewport. Use the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Viewport.GetDIB()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_viewport.html#a06fff8d5d0f45dae674673c4f867c0fd&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">Viewport.GetDIB()</a></span> method.</p>\n\
<p>The following example demonstrates how to get the active viewport, return its graphics window as a bitmap, then save the bitmap to a specified file and path.</p>\n\
<div class=\'codeBlock\'><pre>import MaxPlus\n\
\n\
#Get the active viewport\n\
view = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.ViewportManager.GetActiveViewport\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_viewport_manager.html#a5c988065046ae8c23f886d896630a0f7&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MaxPlus.ViewportManager.GetActiveViewport</a>()\n\
\n\
#Create a bitmap\n\
bm = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateBitmap\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a07ee5f23ef113ffd43794d70546ba7c2&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MaxPlus.Factory.CreateBitmap</a>()\n\
\n\
#Allocate some storage\n\
storage = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateStorage\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#af4f1df3ba6f8da558b15dc4ede6e9491&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MaxPlus.Factory.CreateStorage</a>(7)\n\
\n\
#Get the bitmap info\n\
info = storage.GetBitmapInfo()\n\
\n\
#Set its storage\n\
bm.SetStorage(storage)\n\
\n\
#Delete the storage that was created\n\
bm.DeleteStorage()\n\
\n\
#Call Viewport.GetDIB() to return the active viewport&#39;s graphics window\n\
res = view.GetDIB(info,bm)\n\
\n\
if res:\n\
    #Display the bitmap\n\
    bm.Display()\n\
    \n\
    #Set the output file name and path for the bitmap \n\
    info.SetName(<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.PathManager.GetRenderOutputDir\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_path_manager.html#a190d49f8c48aa8f6a5433cc9d71124c3&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MaxPlus.PathManager.GetRenderOutputDir</a>() + r&#39;\\VPRender.tga&#39;)\n\
\n\
    #Prepare the bitmap for writing to the output file\n\
    bm.OpenOutput(info)\n\
\n\
    #Write the bitmap to the output file\n\
    bm.Write(info)\n\
    bm.Close(info)\n\
</pre></div><p>First, call <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ViewportManager.GetActiveViewport()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_viewport_manager.html#a5c988065046ae8c23f886d896630a0f7&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">ViewportManager.GetActiveViewport()</a></span> to obtain the active viewport. For more information about rendering and the viewport, see <a href=\"#!/url=./developer/maxplus_python_api_introduction/rendering.html\">Rendering</a>.</p>\n\
<p>Then, create the bitmap and allocate its storage. For more information regarding creating and saving bitmaps, see <a href=\"#!/url=./developer/maxplus_python_api_introduction/creating_a_bitmap.html\">Creating a bitmap</a>.</p>\n\
<p>Call <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Viewport.GetDIB()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_viewport.html#a06fff8d5d0f45dae674673c4f867c0fd&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">Viewport.GetDIB()</a></span> to obtain the active viewport&#39;s graphics window as a bitmap.</p>\n\
<p>You can then call <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Bitmap.Display()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_bitmap.html#a564e33f3ffecb08b1f241c3ac6e97d3f&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">Bitmap.Display()</a></span> to display the bitmap, as well as <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Bitmap.OpenOutput()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_bitmap.html#ae6902570d04b450bff1d434f5c49472c&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">Bitmap.OpenOutput()</a></span>, <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Bitmap.Write()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_bitmap.html#af72e5122888132dd3d110c3c3ebb6705&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">Bitmap.Write()</a></span> and <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Bitmap.Close()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_bitmap.html#a386ccd984f92babd18475d91fd92ce0b&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">Bitmap.Close()</a></span> to write the bitmap to an output file. Call <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"BitmapInfo.SetName()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_bitmap_info.html#ae7164557284c72a8f6da140cc32df8df&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">BitmapInfo.SetName()</a></span> to set the output file name.</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";