var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Working with objects</title>\n\
   <meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Working with objects</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"working-with-objects\"></a></div>\n\
<p>Scene objects are objects that you can create and manipulate in the viewport.</p>\n\
<p>They can be: geometry (<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"GeomObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_geom_object.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">GeomObject</a></span>), lights (<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"LightObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_light_object.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">LightObject</a></span>), cameras (<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"CameraObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_camera_object.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">CameraObject</a></span>), and even particles and world space modifiers.</p>\n\
<p>You must create a node for your object for it to appear in the scene. Nodes are implemented by the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"INode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_i_node.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">INode</a></span> class.</p>\n\
<div class=\'section\'><a id=\"creating-an-object\"></a><h2 id=\"creating-an-object\">Creating an object</h2></div>\n\
<p>Use the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Factory.CreateObject()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a291cdcab959e29a78eec14dfd2ca0a99&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Factory.CreateObject()</a></span> and <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Factory.CreateGeomObject()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a3d630028591390310699de24f0a6a658&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Factory.CreateGeomObject()</a></span> methods to create your object. Then create the node for your object with the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Factory.CreateNode()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a5db9618585b8541c4f22a66190a3056f&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Factory.CreateNode()</a></span> method using your object as an input parameter.</p>\n\
<p>Create more than one instance of your object by creating multiple nodes for your object.</p>\n\
<p>See <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"demoMakeInstances.py\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/demo_make_instances_8py-example.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">demoMakeInstances.py</a></span> for an example of how to create an object, and then create multiple nodes to create multiple instances of the object.</p>\n\
<div class=\'section\'><a id=\"setting-the-parameters-for-your-object\"></a><h3 id=\"setting-the-parameters-for-your-object\">Setting the parameters for your object</h3></div>\n\
<p>Set your parameters via the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ParameterBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter_block.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ParameterBlock</a></span> class. For more information regarding the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ParameterBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter_block.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ParameterBlock</a></span> class, see <a href=\"#!/url=./developer/maxplus_python_api_introduction/working_with_parameters_and_the_.html\">Working with parameters and the ParameterBlock class</a>.</p>\n\
<div class=\'section\'><a id=\"modifying-your-object\"></a><h2 id=\"modifying-your-object\">Modifying your object</h2></div>\n\
<p>A modifier transforms an object. Most modifiers are object modifiers that are applied to objects in their own local transform space and perform deformations such as bend, taper, and twist.</p>\n\
<p>A modifier takes an object and either modifies it directly, or creates a new object from the input object. Many modifiers only apply to certain characteristics (that is, channels) of an object such as the vertices or the faces.</p>\n\
<p>Modifiers can be specific to certain types of object, for example, the Volume Select Modifier only works on triangle mesh objects (<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"TriObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_tri_object.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">TriObject</a></span>).</p>\n\
<p>First create the modifier; then set its parameters via the parameter block, and then apply the modifier to the node of the object. The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"demoBentCylinder.py\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/demo_bent_cylinder_8py-example.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">demoBentCylinder.py</a></span> example demonstrates how to bend a cylinder by 45 degrees using the bend object space modifier.</p>\n\
<div class=\'codeBlock\'><pre>obj = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateGeomObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a3d630028591390310699de24f0a6a658&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Factory.CreateGeomObject</a>(MaxPlus.ClassIds.Cylinder)\n\
obj.ParameterBlock.Radius.Value = 10.0\n\
obj.ParameterBlock.Height.Value = 30.0\n\
node = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a5db9618585b8541c4f22a66190a3056f&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Factory.CreateNode</a>(obj)\n\
mod = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateObjectModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a6a68d7cd60f9be762935d98183dbd14b&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Factory.CreateObjectModifier</a>(MaxPlus.ClassIds.Bend)\n\
mod.ParameterBlock.BendAngle.Value = 45.0\n\
node.AddModifier(mod)\n\
</pre></div><div class=\'section\'><a id=\"editing-a-mesh\"></a><h2 id=\"editing-a-mesh\">Editing a mesh</h2></div>\n\
<p>If you want to edit the faces and vertices of a mesh, you must first create a geometry object, then cast it from the geometry object to a <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"TriObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_tri_object.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">TriObject</a></span> and then obtain the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Mesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_mesh.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Mesh</a></span> by using the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"TriObject.GetMesh()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_tri_object.html#abe5441b60cb411140cb38845c7d03e7b&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">TriObject.GetMesh()</a></span> method as follows:</p>\n\
<div class=\'codeBlock\'><pre>geom = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateGeomObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a3d630028591390310699de24f0a6a658&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Factory.CreateGeomObject</a>(MaxPlus.ClassIds.TriMeshGeometry)\n\
tri = MaxPlus.TriObject._CastFrom(geom)\n\
mesh = tri.GetMesh()\n\
</pre></div><p>See <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"demoMeshAndCPV.py\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/demo_mesh_and_c_p_v_8py-example.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">demoMeshAndCPV.py</a></span> for more information.</p>\n\
<div class=\'section\'><a id=\"transforming-scale-rotate-and-position\"></a><h2 id=\"transforming-scale-rotate-and-position\">Transforming: Scale, Rotate and Position</h2></div>\n\
<p>You can scale, rotate, or move an object to a different position via its node. Use the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Point3\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_point3.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Point3</a></span> class to set the scale and position as follows:</p>\n\
<div class=\'codeBlock\'><pre>node.Scaling = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Point3\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_point3.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Point3</a>(3, 3, 3)\n\
node.Position = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Point3\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_point3.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Point3</a>(20, 20, 20)\n\
</pre></div><p>To set the rotation, use <span class=\'code\'>INode.Rotation</span> and provide a quaternion as your input parameter. The quaternion you provide specifies the rotation components for the matrix, and in addition, the translation and scale components of your node are reset to match this matrix.</p>\n\
<p><strong>Note:</strong> Translation and rotation values on an INode do not work the same as in MAXScript. These are non-normalized values, whereas in MAXScript they always are. To get expected values (ie, values similar to MAXScript), you will need to re-scale the transform matrix to scale (1,1,1). For example, box001 has been rotated:</p>\n\
<div class=\'codeBlock\'><pre>print &#39;Transform python pre scale: {0}&#39;.format(<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.INode.GetINodeByName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_i_node.html#afe7c71418b7c20cb28a45475bee2c76e&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.INode.GetINodeByName</a>(&#39;box001&#39;).Transform)\n\
scaledMatrix = (<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.INode.GetINodeByName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_i_node.html#afe7c71418b7c20cb28a45475bee2c76e&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.INode.GetINodeByName</a>(&#39;box001&#39;).Transform)\n\
setToScale = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Point3\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_point3.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Point3</a>(1,1,1) / scaledMatrix.Scale\n\
scaledMatrix.PreScale(setToScale)\n\
print &#39;Rotation python post rescaled to 1 1 1 matrix: {0}&#39;.format(scaledMatrix.Rotation)\n\
</pre></div><div class=\'section\'><a id=\"related-topics\"></a><h2 id=\"related-topics\">Related topics</h2></div>\n\
<ul>\n\
<li><a href=\"#!/url=./developer/maxplus_python_api_introduction/working_with_parameters_and_the_.html\">Working with parameters and the ParameterBlock class</a></li>\n\
</ul>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";