var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Python 3 Warning Mode</title>\n\
   <meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Python 3 Warning Mode</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"python-3-warning-mode\"></a></div>\n\
<p>In 3ds Max 2020.2 Update and later, 3ds Max and 3ds Max Batch support the Py3k warnings mode, where constructs and APIs executed in a Python 2.x script that will not run in Python 3.x generate warnings. This mode allows you to prepare your scripts to run under Python 3.x, which will be supported in a future version of 3ds Max.</p>\n\
<p>When warning mode is enabled, warnings are printed to the MAXScript Listner window or the Max Batch console, and are logged to the <span class=\'code\'>Max.log</span> file. For example:</p>\n\
<div class=\'codeBlock\'><pre class=\"prettyprint lang-py\">&gt;&gt;&gt; print `1+2`\n\
&lt;console&gt;:1: SyntaxWarning: backquote not supported in 3.x; use repr()\n\
</pre></div><p>And a corresponding line is written to the max.log file:</p>\n\
<div class=\'codeBlock\'><pre class=\"prettyprint lang-txt\">2019/06/10 11:30:17 ERR: [31336] [02296] &lt;console&gt;:1: SyntaxWarning: backquote not supported in 3.x; use repr()\n\
<blockquote>\n\
</blockquote></pre></div><p><strong>Note:</strong> The previous example actually generates three warnings. A single construct might generate more than one warning if the scrutinizer uses multiple code paths to analyze it.</p>\n\
\n\
<p>Warnings are generated regardless of how the script is executed, whether from the Listener, from the MAXScript Editor <strong>Evaluate All</strong> command, from the <strong>Scripting &gt; Run Script</strong> menu command, or even when executed from MAXScript using <span class=\'code\'>Python.Execute()</span> or <span class=\'code\'>Python.ExecuteFile()</span>.</p>\n\
<div class=\'section\'><a id=\"turning-on-the-warning-mode\"></a><h2 id=\"turning-on-the-warning-mode\">Turning On the Warning Mode</h2></div>\n\
<p>The warning mode is enabled in one of two ways:</p>\n\
<ul>\n\
<li>passing the <span class=\'code\'>-python3Warning 1</span> option to 3dsmax.exe or 3dsmaxbatch.exe</li>\n\
<li>creating a <span class=\'code\'>ADSK_3DSMAX_PTYHON3_WARNING</span> environment variable with a value of 1/on/yes/true</li>\n\
</ul>\n\
<blockquote>\n\
<p><strong>Note:</strong> The <span class=\'code\'>python3Warning</span> command line option overrides the <span class=\'code\'>ADSK_3DSMAX_PTYHON3_WARNING</span> setting, if they have conflicting settings.</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"migrating-your-code\"></a><h2 id=\"migrating-your-code\">Migrating Your Code</h2></div>\n\
<p>There are many good resources for those who want to migrate their 2.x Python code to 3.x. Here are a few:</p>\n\
<ul>\n\
<li><a href=\'https://docs.python.org/3/howto/pyporting.html\' title=\'\' target=\'_blank\'>Porting Python 2 Code to Python 3 (official)</a></li>\n\
<li><a href=\'https://portingguide.readthedocs.io/en/latest/index.html\' title=\'\' target=\'_blank\'>The Conservative Python 3 Porting Guide</a></li>\n\
<li><a href=\'https://python-future.org/futurize.html\' title=\'\' target=\'_blank\'>Python-Future migration script</a></li>\n\
<li><a href=\'https://docs.python.org/2/library/__future__.html\' title=\'\' target=\'_blank\'>Python <span class=\'code\'>__future__</span> statement documentation</a></li>\n\
</ul>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";