var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Tips and tricks for 3ds Max Python scripting</title>\n\
   <meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Tips and tricks for 3ds Max Python scripting</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"tips-and-tricks-for-3ds-max-python-scripting\"></a></div>\n\
<div class=\'section\'><a id=\"pymxs-tips\"></a><h2 id=\"pymxs-tips\">pymxs Tips</h2></div>\n\
<ul>\n\
<li><p>You can access custom attributes on an object by using <span class=\'code\'>rt.custattributes</span>:</p>\n\
<div class=\'codeBlock\'><pre>from pymxs import runtime as rt\n\
print rt.custattributes.getpblockdefs(rt.custattributes.getdef(rt.getnodebyname(&quot;Sphere001&quot;), 1))\n\
</pre></div><p>Assuming $Sphere001 has a custom float attribute, the result would be:</p>\n\
<div class=\'codeBlock\'><pre>#(#(#main, 0, 0, #(#rollout, #params), #(#myattr, #(#type, #float, #ui, #(#myattr), #default, 0.0))))</pre></div></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"maxplus-tips\"></a><h2 id=\"maxplus-tips\">MaxPlus Tips</h2></div>\n\
<ul>\n\
<li><p>You can import a specific class from MaxPlus, instead of the entire MaxPlus module, into the current namespace. For example, you can do as follows: from MaxPlus import Point3 as MyPoint3 for item in dir(MyPoint3): print item</p>\n\
This example shows how you can expose only the Point3 class of MaxPlus, and how to rename it as you like.</li>\n\
<li><p>You can obtain a list of attributes for a class (list of methods, variables) using <span class=\'code\'>help</span> as follows: import MaxPlus help(MaxPlus.Asset)</p>\n\
In your MAXScript Listener window, you will obtain a list of all attributes for the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Asset\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_asset.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Asset</a></span> class.</li>\n\
<li><p>To find information on the object that a Python command has created, use <span class=\'code\'>type</span> and <span class=\'code\'>help</span> together. In the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"demoActionFactory.py\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/demo_action_factory_8py-example.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">demoActionFactory.py</a></span> example, you can find information on the object that <span class=\'code\'>MaxPlus.ActionFactory.Create</span> has created by adding the <span class=\'code\'>help</span> statement as follows : action = MaxPlus.ActionFactory.Create(&#39;Do something&#39;, &#39;Python demo&#39;, doSomething) help(type(action))</p></li>\n\
<li><p>To obtain a list of attributes and their corresponding values, you can also use the Python built-in <span class=\'code\'>dir()</span> and <span class=\'code\'>getattr()</span> functions. For example, you add the following statements to <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"demoActionFactory.py\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/demo_action_factory_8py-example.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">demoActionFactory.py</a></span>:</p>\n\
<div class=\'codeBlock\'><pre>action = MaxPlus.ActionFactory.Create(&#39;Do something&#39;, &#39;Python demo&#39;, doSomething)\n\
at = type(action) \n\
for k in dir(at): \n\
    print &quot;I have an attribute named &quot;, k, &quot; which has a value, &quot;, getattr(action, k) \n\
</pre></div><p>The <span class=\'code\'>dir(object)</span> function, when passed an argument (object), returns a list of attributes for the object.</p>\n\
<p>The <span class=\'code\'>getattr(object, name)</span> function returns the value of the named attribute of the object.</p></li>\n\
<li><p>There are a number of classes that are enumerable. That is, they support the <span class=\'code\'>for</span> statement. For example, you can do as follows:</p>\n\
<div class=\'codeBlock\'><pre>import MaxPlus\n\
xs = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.IntList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_int_list.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.IntList</a>()\n\
xs.Append(3)\n\
xs.Append(4)\n\
xs.Append(5)\n\
for x in xs:\n\
    print x \n\
</pre></div><p>Some of these classes include lists such as: <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Point3List\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_point3_list.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Point3List</a></span>, <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Point4List\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_point4_list.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Point4List</a></span>, <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"StrList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_str_list.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">StrList</a></span>, <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ReferenceTargetList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_reference_target_list.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">ReferenceTargetList</a></span>, <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"IntList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_int_list.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">IntList</a></span>, <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"FloatList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_float_list.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FloatList</a></span> and so forth.</p></li>\n\
<li><p>You can create an exclusion list, for example, so that specific nodes are excluded from being illuminated by a light. Create an exclusion list for your object (for example, your light) using <span class=\'code\'>ParameterBlock.excludeList</span>. Then create a node for the object that you want to exclude and append the node to the exclude list. An example is as follows:</p>\n\
<div class=\'codeBlock\'><pre>import MaxPlus\n\
#Create your light\n\
obj = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateOmniLight\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#af0e59c51633057fa4374c39eb78f7d63&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.Factory.CreateOmniLight</a>()\n\
\n\
#Create an exclusion list for your light \n\
excludeList = obj.ParameterBlock.excludeList  \n\
v = excludeList.Value\n\
\n\
#Create a node for the object you want to exclude\n\
node = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a5db9618585b8541c4f22a66190a3056f&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.Factory.CreateNode</a>(<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateGeomObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a3d630028591390310699de24f0a6a658&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.Factory.CreateGeomObject</a>(MaxPlus.ClassIds.Cone)) \n\
\n\
#Append the node to the exclude list\n\
v.Append(node)\n\
\n\
#Tie the exclude list back to the Value property  \n\
excludeList.Value = v \n\
\n\
#Create a node for your light object\n\
LightNode = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a5db9618585b8541c4f22a66190a3056f&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.Factory.CreateNode</a>(obj)\n\
</pre></div><p>Now if you select <span class=\'code\'>LightNode</span>, then click <strong>Exclude</strong> in the <strong>Modify</strong> panel in the UI, you can see that the cone belongs to the light&#39;s exclusion list.</p>\n\
<p><strong>Tip</strong>You can select a node by using the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"INode.Select()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_i_node.html#a15138e3b9c23c5fd69341781517f15bb&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">INode.Select()</a></span> method; for example <span class=\'code\'>LightNode.Select()</span> will select the light node you just created in the above example.</p></li>\n\
<li>Many methods take a <span class=\'code\'>TimeValue</span> parameter. You can use <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Core.GetCurrentTime()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_core.html#a64e5daad3eabd66bdddb26ac04e31338&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Core.GetCurrentTime()</a></span> to obtain the current time to provide to these methods.</li>\n\
<li><p>You can access custom attributes on an object by executing some MAXScript, and using the returned FPValue: eval_str = &quot;custAttributes.getPBlockDefs (custAttributes.getDef $Sphere001 1)&quot; r = MaxPlus.Core.EvalMAXScript(eval_str) print MaxPlus.FPTypeGetName(r.Type) print r.Get()</p></li>\n\
</ul>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";