var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Using pymxs</title>\n\
   <meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Using pymxs</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"using-pymxs\"></a></div>\n\
<p>The <span class=\'code\'>pymxs</span> Python module provides a wrapper for the MAXScript engine, and exposes virtually all the interfaces, globals, and classes available in MAXScript. The MAXScript help describes all the MAXScript objects and functions available to pymxs, while these topics cover some of the ways Python interoperates with MAXScript.</p>\n\
<div class=\'section\'><a id=\"using-the-maxscript-runtime-in-python\"></a><h2 id=\"using-the-maxscript-runtime-in-python\">Using the MAXScript Runtime in Python</h2></div>\n\
<p>The <span class=\'code\'>pymxs</span> module exposes the MAXScript runtime, and all the global symbols it contains, to Python scripts. The runtime is dynamic, so global objects created in MAXScript are subsequently available to <span class=\'code\'>pymxs.runtime</span>.</p>\n\
<p>The names of objects available in the <span class=\'code\'>pymxs.runtime</span> module correspond to MAXScript globals. So, for example, to create a teapot you can use the MAXScript <span class=\'code\'>Teapot()</span> constructor like this:</p>\n\
<div class=\'codeBlock\'><pre>&gt;&gt;&gt; import pymxs\n\
&gt;&gt;&gt; rt = pymxs.runtime\n\
&gt;&gt;&gt; t = rt.Teapot()\n\
&gt;&gt;&gt; rt.classOf(t)\n\
&lt;GeometryClass&lt;Teapot&gt;&gt;\n\
</pre></div><div class=\'section\'><a id=\"printing-to-the-listener-with-pymxs\"></a><h2 id=\"printing-to-the-listener-with-pymxs\">Printing to the Listener with pymxs</h2></div>\n\
<p>Both MAXScript <span class=\'code\'>print()</span> and <span class=\'code\'>assert()</span> functions are disabled and not callable from pymxs.runtime. There are a couple of ways to work around this limitation to send messages to the Listener window. The simplest is to use the standard Python <span class=\'code\'>print()</span> function and <span class=\'code\'>assert</span> statement.</p>\n\
<p>The pymxs module has a special <span class=\'code\'>print_()</span> function that gives you more control over error formatting and threading behavior:</p>\n\
<div class=\'codeBlock\'><pre class=\"prettyprint lang-py\">pymxs.print_(msg[, isErr[, [forceOnMainThread]])\n\
</pre></div><ul>\n\
<li><span class=\'code\'>msg</span> - the string to print.</li>\n\
<li><span class=\'code\'>isErr</span> - an optional boolean that indicates whether the message should be formatted as an error (in red, by default). The default is False.</li>\n\
<li><span class=\'code\'>forceOnMainThread</span> - an optional boolean that indicates whether the print should happen on the main thread. In a threaded script, setting this to True ensures that output is sent to the Listener window even if called from a worker thread. If False, when called from a worker thread, output is sent to stdout/stderr (the <em>3dsmax_ouput.log</em> file or console). The default is True.</li>\n\
</ul>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";