var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>pymxs API Introduction</title>\n\
   <meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>pymxs API Introduction</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"pymxs-api-introduction\"></a></div>\n\
<p>The <span class=\'code\'>pymxs</span> Python module provides a wrapper for the MAXScript engine, and exposes virtually all the interfaces, globals, and classes available in MAXScript.</p>\n\
<div class=\'section\'><a id=\"maxscript-undo-system\"></a><h2 id=\"maxscript-undo-system\">MAXScript Undo System</h2></div>\n\
<p>The undo system is exposed in <span class=\'code\'>pymxs</span> with:</p>\n\
<ul>\n\
<li><span class=\'code\'>pymxs.undo(True|False)</span></li>\n\
<li><span class=\'code\'>pymxs.run_undo()</span></li>\n\
<li><span class=\'code\'>pymxs.run_redo()</span></li>\n\
</ul>\n\
<p>As with MAXScript, operations run through pymxs are not recorded by the undo system. Undo must be specifically enabled. Undoable pymxs operations appear as items labeled <em>MAXScript</em> in the 3ds Max Undo menu.</p>\n\
<p>For example, to create a teapot, change its position, and then undo the change:</p>\n\
<div class=\'codeBlock\'><pre>import pymxs\n\
rt = pymxs.runtime\n\
# this will not be undoable:\n\
with pymxs.undo(False):\n\
    t = rt.Teapot()\n\
\n\
with pymxs.undo(True):\n\
    t.pos = rt.Point3(20,20,20)\n\
\n\
pymxs.run_undo() # undo the position\n\
pymxs.run_redo() # redo the position\n\
</pre></div><div class=\'section\'><a id=\"multi-threading-with-maxscript\"></a><h2 id=\"multi-threading-with-maxscript\">Multi-threading With MAXScript</h2></div>\n\
<p>You cannot call <em>pymxs.runtime</em> commands directly on a worker thread, as this will cause a runtime exception. However, <em>pymxs</em> has a <span class=\'code\'>mxstoken()</span> function to support multi-threading by providing a synchronization mechanism between worker threads.</p>\n\
<p>For an example of this approach, see the example <span class=\"filePath\" translate=\"no\">&lt;maxdirectory&gt;\\scripts\\Python\\demoMXSToken.py</span>.</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";