var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>MAXScript Context Expressions</title>\n\
   <meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>MAXScript Context Expressions</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"maxscript-context-expressions\"></a></div>\n\
<p>The <span class=\'code\'>pymxs</span> module exposes MAXScript context expressions that can be used in conjunction with the Python <span class=\'code\'>with</span> statement. These expressions are:</p>\n\
<ul>\n\
<li><span class=\'code\'>pymxs.animate(True|False)</span></li>\n\
<li><span class=\'code\'>pymxs.attime(True|False)</span></li>\n\
<li><span class=\'code\'>pymxs.atlevel(True|False)</span></li>\n\
<li><span class=\'code\'>pymxs.quiet(True|False)</span></li>\n\
<li><span class=\'code\'>pymxs.redraw(True|False)</span></li>\n\
<li><span class=\'code\'>pymxs.undo(True|False)</span></li>\n\
<li><span class=\'code\'>pymxs.mxstoken()</span> - See &#39;Multi-Threading with MAXScript&#39; below.</li>\n\
</ul>\n\
<p>For example, to create a teapot and animate it:</p>\n\
<div class=\'codeBlock\'><pre>import pymxs\n\
at = pymxs.attime\n\
rt = pymxs.runtime\n\
t = rt.Teapot()\n\
\n\
with pymxs.animate(True):\n\
with at(1):\n\
    t.pos = rt.Point3(2,2,2)\n\
with at(12):\n\
    t.pos = rt.Point3(10, 10, 10)\n\
with at(21):\n\
    t.pos = rt.Point3(20,20,20)\n\
</pre></div><div class=\'section\'><a id=\"undo-redo-and-exceptions\"></a><h2 id=\"undo-redo-and-exceptions\">Undo / Redo and Exceptions</h2></div>\n\
<p>The way an undo block in pymxs handles exceptions is different than in MAXScript. When an exception is raised, code executed before the exception is undone. The exception is not raised beyond the scope of the undo block, as the undo operation is considered to be the exception handler. Here is an example to illustrate this behavior:</p>\n\
<div class=\'codeBlock\'><pre class=\"prettyprint lang-py\"># undo with exception\n\
\n\
import pymxs\n\
from pymxs import runtime as rt\n\
\n\
def make_box_and_raise():\n\
    with pymxs.undo(True, &#39;Making box&#39;):\n\
        rt.Box()\n\
        # this will undo the box, and the error will not show up\n\
        # in the listener, because it is handled:\n\
        raise RuntimeError(&#39;This is an error&#39;)\n\
        \n\
def make_sphere_and_raise():\n\
    rt.Sphere()\n\
    # this will show up in the lister as an unhandled exception\n\
    raise RuntimeError(&#39;This is an error&#39;)\n\
\n\
make_box_and_raise()\n\
make_sphere_and_raise()\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";