var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>What&#39;s New in the 3ds Max 2017 Python API</title>\n\
   <meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>What&#39;s New in the 3ds Max 2017 Python API</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"whats-new-in-the-3ds-max-2017-python-api\"></a></div>\n\
<p>This release of 3ds Max introduces several changes and improvements to the Max Python API.</p>\n\
<div class=\'section\'><a id=\"python-version\"></a><h2 id=\"python-version\">Python Version</h2></div>\n\
<p>The version of Python that ships with 3ds Max is now 2.7.6.</p>\n\
<p>The Python interpreter is located in the 3ds Max install directory, and is named 3dsmaxpy.exe. This is provided to allow external execution, for example to provide integration with package management with PIP. Note: PIP is not included with Python 2.7.6, but you can install it. See the &quot;Python extension libraries&quot; topic for more information.</p>\n\
<div class=\'section\'><a id=\"maxscript-editor-and-listener-python-language-support\"></a><h2 id=\"maxscript-editor-and-listener-python-language-support\">MAXScript Editor and Listener Python Language Support</h2></div>\n\
<p>The MaxScript editor now has Python language support, including syntax highlighting, auto-completion, and the ability to execute Python scripts from the editor. This simplifies writing and executing Python, which no longer has to be passed as a string or file to <span class=\'code\'>Python.Execute()</span> or <span class=\'code\'>Python.ExecuteFile()</span> via MaxScript.</p>\n\
<p>The MaxScript editor now supports &quot;split&quot; view - with two scripts side-by-side. To enable this feature, drag the tab of an open document and select &quot;Clone to another view&quot; or &quot;Move to another view&quot;.</p>\n\
<p>The listener now supports a Python command line, including the ability to enter multi-line blocks of code. The buffer is executed by entering <strong>Ctrl+Enter</strong>. Enter Python mode by either selecting the <strong>Python</strong> radio button, or entering<span class=\'code\'>\\&gt;&gt;\\&gt;</span> and a space on the MaxScript command line.</p>\n\
<div class=\'section\'><a id=\"python-libraries-available-in-maxscript\"></a><h2 id=\"python-libraries-available-in-maxscript\">Python libraries available in MAXScript</h2></div>\n\
<p>Python libraries can now be &quot;imported&quot; into MaxScript scripts using <span class=\'code\'>Python.import()</span>. Modules can be re-loaded using <span class=\'code\'>Python.reload()</span>.</p>\n\
<p>See &quot;Using Python Libraries in MAXScript&quot; for more information.</p>\n\
<div class=\'section\'><a id=\"maxscript-api-available-in-python\"></a><h2 id=\"maxscript-api-available-in-python\">MAXScript API available in Python</h2></div>\n\
<p>The full MAXScript runtime is now available to Python scripts via the new <span class=\'code\'>pymxs.runtime</span> module. This module exposes all the global symbols of MAXScript.</p>\n\
<p>The MAXScript context expressions animate, at time, at level, quiet, and redraw are available in <span class=\'code\'>pymxs</span>. This module also exposes the MAXScript undo/redo and runundo/runredo commands. It provides a mechanism to call <em>pymxs.runtime</em> commands from a worker thread with <span class=\'code\'>pymxs.mxstoken</span>.</p>\n\
<p>See <a href=\"#!/url=./developer/using_pymxs/pymxs_api_introduction.html\">pymxs API Introduction</a> for more information.</p>\n\
<div class=\'section\'><a id=\"maxplus-qt-interoperation-improvements\"></a><h2 id=\"maxplus-qt-interoperation-improvements\">MaxPlus / Qt Interoperation Improvements</h2></div>\n\
<div class=\'section\'><a id=\"better-pyside-support\"></a><h3 id=\"better-pyside-support\">Better PySide Support</h3></div>\n\
<p>All PySide libraries are now included in the 3ds Max Python distribution, instead of just a sub-set, and the PySide version is upgraded to 1.2.2, QtCore version 4.8.5.</p>\n\
<p>You can now properly parent a PySide widget to the 3ds Max main window by using <span class=\'code\'>MaxPlus.AttachQWidgetToMax()</span>. (Introduced in the 3ds Max 2016 Ext 1 release).</p>\n\
<blockquote>\n\
<p><strong>Note:</strong> The preferred method for parenting to the 3ds Max main window is to use <span class=\'code\'>MaxPlus.GetQMaxWindow()</span>, as discussed above.</p>\n\
</blockquote>\n\
<p>The <span class=\'code\'>pysideuic</span> module is now pre-installed, so that Qt Designer UI files may be easily loaded at runtime. See &quot;Loading Qt UI Files&quot; below.</p>\n\
<div class=\'section\'><a id=\"window-parenting\"></a><h3 id=\"window-parenting\">Window Parenting</h3></div>\n\
<p>MaxPlus now directly exposes the 3ds Max main window as a QWinWidget, with MaxPlus.GetQMaxWindow(). Here is an example of using this API to set the main window as the widget parent:</p>\n\
<div class=\'codeBlock\'><pre>w = QtGui.QWidget()\n\
w.setParent(MaxPlus.GetQMaxWindow()) # by default the QWidget is modeless\n\
</pre></div><p>For a modal dialog, use this approach:</p>\n\
<div class=\'codeBlock\'><pre>w = QtGui.QWidget()\n\
w.setParent(MaxPlus.GetQMaxWindow())\n\
w.exec_() # display modal\n\
</pre></div><div class=\'section\'><a id=\"widget-docking\"></a><h3 id=\"widget-docking\">Widget Docking</h3></div>\n\
<p>You can now dock Qt widgets to the 3ds Max UI, using <span class=\'code\'>MaxPlus.MakeQWidgetDockable(w, pos_flag)</span>.</p>\n\
<p>The <span class=\'code\'>pos_flag</span> argument is a bit flag:</p>\n\
<ul>\n\
<li>1 = top</li>\n\
<li>2 = bottom</li>\n\
<li>4 = left</li>\n\
<li>8 = right</li>\n\
</ul>\n\
<p>You can OR or add values to combine them.</p>\n\
<p>For example:</p>\n\
<div class=\'codeBlock\'><pre>import MaxPlus\n\
from PySide.QtGui import *\n\
w = QWidget()\n\
MaxPlus.MakeQWidgetDockable(w, 14), #Make dockable on Left, Right and Bottom\n\
</pre></div><div class=\'section\'><a id=\"loading-qt-ui-files\"></a><h3 id=\"loading-qt-ui-files\">Loading Qt UI Files</h3></div>\n\
<p>The pysideuic module is now pre-installed, and MaxPlus now includes a facility for loading UI files created by Qt Designer at runtime, <span class=\'code\'>MaxPlus.LoadUiType()</span>:</p>\n\
<div class=\'codeBlock\'><pre>uitype, basetype = MaxPlus.LoadUiType(uifile)\n\
</pre></div><p>For example:</p>\n\
<div class=\'codeBlock\'><pre>import pysideuic\n\
from PySide import QtCore, QtGui\n\
\n\
fname = &quot;scripts/python/example.ui&quot;\n\
formt, btype = MaxPlus.LoadUiType(fname)\n\
\n\
class TestWidget(btype, formt):\n\
    def __init__(self, parent=None):\n\
        btype.__init__(self)\n\
        formt.__init__(self)\n\
        self.setupUi(self)\n\
\n\
form = TestWidget()\n\
form.show()\n\
</pre></div><div class=\'section\'><a id=\"maxplus-improvements\"></a><h2 id=\"maxplus-improvements\">MaxPlus Improvements</h2></div>\n\
<p>The AppData Chunk API has been exposed in MaxPlus. See the <em>demoAppChunk.py</em> sample script for an illustration of how to use this API.</p>\n\
<p>The Quad Poly API has been exposed in MaxPlus. See the demoPolyObject.py sample script for an illustration of how to use this API.</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"SplineShape.UpdateShape()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_spline_shape.html#a89300428e916a673bb86d8a37d15aa17&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">SplineShape.UpdateShape()</a></span> has been added to update a spline in the 3ds Max scene. This is similar to the MAXScript UpdateShape function.</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";