var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Working with parameters and the ParameterBlock class</title>\n\
   <meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Working with parameters and the ParameterBlock class</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"working-with-parameters-and-the-parameterblock-class\"></a></div>\n\
<p>Many 3ds Max features are implemented as plug-ins and expose properties at run-time using a mechanism called a <em>parameter block</em>. This is hidden from MAXScript users, but in Python these properties are accessible explicitly using a <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ParameterBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter_block.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ParameterBlock</a></span> class, which is accessible on any <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Animatable\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_animatable.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Animatable</a></span> derived class via the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Animatable.GetParameterBlock()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_animatable.html#afd3932c7e37bf8d6cf088bab7cd3faec&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Animatable.GetParameterBlock()</a></span> function or the equivalent <span class=\'code\'>Animatable.ParameterBlock</span> property.</p>\n\
<p>Many of these run-time parameters are documented in the MAXScript documentation, and in most cases, the names of the parameters are the same as those of MAXScript.</p>\n\
<p>You can set or query the dynamic parameters of 3ds Max objects via the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ParameterBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter_block.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ParameterBlock</a></span> class. The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ParameterBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter_block.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ParameterBlock</a></span> class wraps the parameters exposed via 3ds Max&#39;s <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"IParamBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_i_param_block.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">IParamBlock</a></span> and <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"IParamBlock2\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_i_param_block2.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">IParamBlock2</a></span> classes. Examples of these types of parameters are the radius of a sphere object and the angle of a bend modifier.</p>\n\
<p>Unlike MAXScript, when you access a parameter, you do not get the value of the parameter, rather you get a <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span> instance that wraps the parameter, and you then get/set properties on that <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span> instance.</p>\n\
<div class=\'section\'><a id=\"setting-the-parameters-for-an-object\"></a><h2 id=\"setting-the-parameters-for-an-object\">Setting the parameters for an object</h2></div>\n\
<p>Set your parameters via the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ParameterBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter_block.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ParameterBlock</a></span> class, for example, as follows:</p>\n\
<div class=\'codeBlock\'><pre>obj = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateGeomObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a3d630028591390310699de24f0a6a658&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Factory.CreateGeomObject</a>(MaxPlus.ClassIds.Sphere)\n\
obj.ParameterBlock.Radius.Value = 5.0\n\
node = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a5db9618585b8541c4f22a66190a3056f&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Factory.CreateNode</a>(obj)\n\
</pre></div><p>Unlike MAXScript, parameters are searched for only on the object specified. Thus, if you have an <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"INode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_i_node.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">INode</a></span> instance and you access its <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ParameterBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter_block.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ParameterBlock</a></span>, you get the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ParameterBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter_block.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ParameterBlock</a></span> on the node itself. You can also access parameters on the base object via <span class=\'code\'>INode.BaseObject</span>, for example, as follows:</p>\n\
<div class=\'codeBlock\'><pre>obj = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateGeomObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a3d630028591390310699de24f0a6a658&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Factory.CreateGeomObject</a>(MaxPlus.ClassIds.Cylinder)\n\
node = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a5db9618585b8541c4f22a66190a3056f&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Factory.CreateNode</a>(obj)\n\
node.BaseObject.ParameterBlock.Radius.Value = 10.0\n\
node.BaseObject.ParameterBlock.Height.Value = 30.0\n\
</pre></div><div class=\'section\'><a id=\"querying-the-methods-and-properties-of-parameterblock\"></a><h2 id=\"querying-the-methods-and-properties-of-parameterblock\">Querying the methods and properties of ParameterBlock</h2></div>\n\
<p>Use the <span class=\'code\'>help</span> command as follows to obtain the list of methods and properties of <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ParameterBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter_block.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ParameterBlock</a></span>:</p>\n\
<div class=\'codeBlock\'><pre>import MaxPlus\n\
help(<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.ParameterBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter_block.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.ParameterBlock</a>) \n\
</pre></div><div class=\'section\'><a id=\"enumerate-across-the-parameters-in-a-parameterblock\"></a><h2 id=\"enumerate-across-the-parameters-in-a-parameterblock\">Enumerate across the Parameters in a ParameterBlock</h2></div>\n\
<p>A <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ParameterBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter_block.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ParameterBlock</a></span> holds a list of <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>s. To query the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>s available in the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ParameterBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter_block.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ParameterBlock</a></span> that you set for your object, do as follows:</p>\n\
<div class=\'codeBlock\'><pre>obj = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateGeomObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a3d630028591390310699de24f0a6a658&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Factory.CreateGeomObject</a>(MaxPlus.ClassIds.Sphere)\n\
for p in obj.ParameterBlock.Parameters:\n\
    print p.Name, p.Value\n\
</pre></div><p><span class=\'code\'>p in obj.ParameterBlock.Parameters</span> retrieves each of the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>s from the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ParameterBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter_block.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ParameterBlock</a></span>. The name and current value for each of the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>s are then printed out.</p>\n\
<blockquote>\n\
<p><strong>Note:</strong> The names of the dynamic properties exposed by <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ParameterBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter_block.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ParameterBlock</a></span> are not case sensitive.</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"querying-the-methods-and-properties-of-parameters\"></a><h2 id=\"querying-the-methods-and-properties-of-parameters\">Querying the methods and properties of Parameters</h2></div>\n\
<p>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span> class also has its own set of methods and properties. To query these, do as follows:</p>\n\
<div class=\'codeBlock\'><pre>import MaxPlus\n\
help(<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Parameter</a>)\n\
</pre></div><p>A description of its methods and properties is as follows:</p>\n\
<ul>\n\
<li><span class=\'code\'>Parameter.Controller</span> / <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter.GetController()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html#ae61db6264fb35dbf39d504ed5ffcbab2&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter.GetController()</a></span>, <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter.SetController()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html#aeea12ac235b71477a642a67f20c8da51&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter.SetController()</a></span> - get/set the controller on the parameter. For example, if you animate the radius of a sphere, <span class=\'code\'>mySphereObj.ParameterBlock.Radius.Controller</span> would return the controller for the radius. An error occurs if you attempt to set a non-animatable or read-only property.</li>\n\
<li><span class=\'code\'>Parameter.IsAnimatable</span> / <span class=\'code\'>Parameter.IsAnimatable()</span> - determine if the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span> is animatable.</li>\n\
<li><span class=\'code\'>Parameter.IsArrayData</span> / <span class=\'code\'>Parameter.IsArrayData()</span> - determine if the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span> is a type of array. <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter.GetValue()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html#a36ac0216b5a025637ffeb29aa3b1d16d&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter.GetValue()</a></span> returns an array containing values at the current time.</li>\n\
<li><p><span class=\'code\'>Parameter.IsArrayParameter</span> / <span class=\'code\'>Parameter.IsArrayParameter()</span> - determine if the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span> is a specific type of array, where the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span> can be cast to <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ArrayParameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_array_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ArrayParameter</a></span> via ap = MaxPlus.ArrayParameter._CastFrom(p)</p>\n\
See <a href=\'working_with_parameters_and_the_.html#arrayparameters\' title=\'\'>ArrayParameters</a> for more information.</li>\n\
<li><span class=\'code\'>Parameter.IsObsolete</span> / <span class=\'code\'>Parameter.IsObsolete()</span> - determine if the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span> was defined as obsolete by the object. When you enumerate over the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>s in a <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ParameterBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter_block.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ParameterBlock</a></span>, obsolete <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>s are not included. But you can still access them by name. This prevents breakage of scripts when a <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span> becomes obsolete.</li>\n\
<li><span class=\'code\'>Parameter.IsReadOnly</span> / <span class=\'code\'>Parameter.IsReadOnly()</span> - determine if the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span> is read-only.</li>\n\
<li><span class=\'code\'>Parameter.Name</span> / <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter.GetName()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html#a7419c988da18601ca5ab25a8a1a9d04b&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter.GetName()</a></span> - obtain the name of the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>.</li>\n\
<li><span class=\'code\'>Parameter.TabIndex</span> / <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter.GetTabIndex()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html#ae8b462b3a4a489f94f6d018fd5d4ea32&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter.GetTabIndex()</a></span> - Allow <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>s to point to a specific item within an <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ArrayParameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_array_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ArrayParameter</a></span>. Read only.</li>\n\
<li><span class=\'code\'>Parameter.Type</span> / <span class=\'code\'>Parameter.GetType()</span> - The numeric type associated with the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>. Read only. The types for<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>s is a subset of the types for <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"FPValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_f_p_value.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">FPValue</a></span>s. See <a href=\"#!/url=./developer/executing_maxscript_from_python.html\">Executing MAXScript from Python</a>.</li>\n\
<li><span class=\'code\'>Parameter.Value</span> / <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter.GetValue()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html#a36ac0216b5a025637ffeb29aa3b1d16d&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter.GetValue()</a></span>, <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter.SetValue()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html#ad045d07cba5c6c119cdf9e9eabd999f8&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter.SetValue()</a></span> - get/set the value of the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>. An error occurs if you try to set a <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span> that is read only, or the value specified cannot be converted to the type expected by the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>. For example, you can&#39;t assign a string to a float parameter.</li>\n\
<li><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter.ReplaceController()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html#af5f18345e6ab2acaffb285d617629153&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter.ReplaceController()</a></span> / <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter.SetController()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html#aeea12ac235b71477a642a67f20c8da51&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter.SetController()</a></span> - If a <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span> already has a controller assigned to it, <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter.ReplaceController()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html#af5f18345e6ab2acaffb285d617629153&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter.ReplaceController()</a></span> will attempt to copy information from the existing controller to the controller being assigned. <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter.SetController()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html#aeea12ac235b71477a642a67f20c8da51&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter.SetController()</a></span> will not copy the information.</p>\n\
<p>There are two implementations of <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter.SetController()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html#aeea12ac235b71477a642a67f20c8da51&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter.SetController()</a></span>:</p>\n\
<div class=\'codeBlock\'><pre>SetController(Parameter self, Control c)\n\
SetController(Parameter self, Control c, bool preserveFrame0Value) \n\
</pre></div><p>By default, <span class=\'code\'>preserveFrame0Value</span> is set to true; therefore, if you choose the first implementation, or set <span class=\'code\'>preserveFrame0Value</span> to <span class=\'code\'>True</span>, then the controller takes on the existing value of the parameter at frame 0. For example, if a controller is assigned to the radius property using <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter.SetController()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html#aeea12ac235b71477a642a67f20c8da51&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter.SetController()</a></span>, and the existing value of radius is 50; after assigning the controller, the frame 0 value of the controller is also 50.</p></li>\n\
</ul>\n\
<p>If <span class=\'code\'>Parameter.IsArrayData</span> is <span class=\'code\'>True</span>, <span class=\'code\'>Parameter.Value</span> will return a list containing the current values for the parameter. This list is not connected to the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>, and changing the size or contents of the list does not affect the value of the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>. If <span class=\'code\'>Parameter.IsReadOnly</span> and <span class=\'code\'>Parameter.IsArrayParameter</span> are <span class=\'code\'>False</span>, then after modifying the list, you can assign the list back to the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span> by assigning it to the <span class=\'code\'>Parameter.Value</span> property.</p>\n\
<p>For certain <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span> types, such as <span class=\'code\'>FPTypeConstants.Angle</span> (<span class=\'code\'>Type</span> value 5), the parameter value shown in the UI, MAXScript, and Python is not the same as the value stored in the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>. Instead, <em>dimensioning</em> is applied to the UI/MAXScript/Python value while <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span> holds the internal data value (undimensioned). In the case of <span class=\'code\'>FPTypeConstants.Angle</span>, the displayed value is in degrees, while the stored value is in radians. This dimensioning is normally invisible to the user, but can come into play when dealing with controllers assigned to these parameters, as the controllers will store the actual value (that is, the internal data value), and the dimensioning information is not held by the controller (a controller can be assigned to multiple parameters with different dimensioning).</p>\n\
<p>The parameter types with dimensioning are:</p>\n\
<p><span class=\'code\'>FPTypeConstants.Rgb</span> (<span class=\'code\'>Type</span> value 2) - displayed: 0-255; stored: 0-1</p>\n\
<p><span class=\'code\'>FPTypeConstants.Angle</span> (<span class=\'code\'>Type</span> value 5) - displayed: degrees; stored: radians</p>\n\
<p><span class=\'code\'>FPTypeConstants.PercentFraction</span> (<span class=\'code\'>Type</span> value 6) - displayed: 0-100; stored: 0-1</p>\n\
<p><span class=\'code\'>FPTypeConstants.Hsv</span> (<span class=\'code\'>Type</span> value 10) - displayed: 0-255; stored: 0-1</p>\n\
<p><span class=\'code\'>FPTypeConstants.ColorChannel</span> (<span class=\'code\'>Type</span> value 11) - displayed: 0-255; stored: 0-1</p>\n\
<p><span class=\'code\'>FPTypeConstants.RgbTab</span> (<span class=\'code\'>Type</span> value 2050) - displayed: 0-255; stored: 0-1</p>\n\
<p><span class=\'code\'>FPTypeConstants.AngleTab</span> (<span class=\'code\'>Type</span> value 2053) - displayed: degrees; stored: radians</p>\n\
<p><span class=\'code\'>FPTypeConstants.PercentFractionTab</span> (<span class=\'code\'>Type</span> value 2054) - displayed: 0-100; stored: 0-1</p>\n\
<p><span class=\'code\'>FPTypeConstants.HsvTab</span> (<span class=\'code\'>Type</span> value 2058) - displayed: 0-255; stored: 0-1</p>\n\
<p><span class=\'code\'>FPTypeConstants.ColorChannelTab</span> (<span class=\'code\'>Type</span> value 2059) - displayed: 0-255; stored: 0-1</p>\n\
<div class=\'section\'><a id=\"accessing-a-parameter\"></a><h3 id=\"accessing-a-parameter\">Accessing a Parameter</h3></div>\n\
<p>You can access a <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span> to get or set its properties or call its methods by doing any of the following:</p>\n\
<ul>\n\
<li><span class=\'code\'>\\&lt;Parameterblock&gt;.&lt;name&gt;</span>; for example, <span class=\'code\'>obj.ParameterBlock.Radius.Value = 10.0</span></li>\n\
<li><span class=\'code\'>\\&lt;Parameterblock&gt;.GetParamByName(&lt;name&gt;)</span>; for example, <span class=\'code\'>obj.ParameterBlock.GetParamByName(&#39;Radius&#39;).Value = 10.0</span></li>\n\
<li><span class=\'code\'>\\&lt;Parameterblock&gt;.GetItem(&lt;index&gt;)</span>; for example, <span class=\'code\'>obj.ParameterBlock.GetItem(0).Value = 10.0</span></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"arrayparameters\"></a><h2 id=\"arrayparameters\">ArrayParameters</h2></div>\n\
<p>An <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ArrayParameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_array_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ArrayParameter</a></span> can be thought of an array of <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>s. As mentioned above, if <span class=\'code\'>IsArrayParameter</span> is set to <span class=\'code\'>true</span>, you can cast your <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span> to an <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ArrayParameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_array_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ArrayParameter</a></span> by doing the following:</p>\n\
<div class=\'codeBlock\'><pre>ap = MaxPlus.ArrayParameter._CastFrom(p)\n\
</pre></div><p>To obtain the methods and properties of <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ArrayParameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_array_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ArrayParameter</a></span>, do as follows: <sub>~</sub> import MaxPlus help(MaxPlus.ArrayParameter) <sub>~</sub></p>\n\
<p>In addition to the methods and properties for <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>, <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ArrayParameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_array_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ArrayParameter</a></span> also has the following properties and methods:</p>\n\
<ul>\n\
<li><span class=\'code\'>ArrayParameter.IsResizable</span> / <span class=\'code\'>ArrayParameter.IsResizable()</span> - get whether the array is resizable.</li>\n\
<li><span class=\'code\'>ArrayParameter.NumItems</span> / <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ArrayParameter.Count()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_array_parameter.html#ab97baf1119bb6336c286c07df26c6585&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ArrayParameter.Count()</a></span> - get the number of items. To resize, use <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ArrayParameter.SetCount()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_array_parameter.html#a45022aa08da8eabe3817b9d652a6f0b7&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ArrayParameter.SetCount()</a></span>.</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ArrayParameter.Delete()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_array_parameter.html#a8058644eb2ac94f286d0f2340f2f00c3&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ArrayParameter.Delete()</a></span> - method that allows you to resize the array by deleting items.</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ArrayParameter.Insert()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_array_parameter.html#a3515f3c97edd40c366d11480a594c433&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ArrayParameter.Insert()</a></span> - method that allows you to resize the array by inserting an item.</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ArrayParameter.Append()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_array_parameter.html#aa223dc35bf3adddc52ce6c37c50c6889&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ArrayParameter.Append()</a></span> - method that allows you to resize the array by appending an item.</li>\n\
</ul>\n\
<blockquote>\n\
<p><strong>Note:</strong> <span class=\'code\'>Delete()</span>, <span class=\'code\'>Insert()</span>, and <span class=\'code\'>Append()</span> are not commonly used methods. They are only used for certain kinds of plug-ins, such as scripted custom attributes, and are targeted towards advanced users.</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"enumerate-across-the-items-in-an-arrayparameter\"></a><h2 id=\"enumerate-across-the-items-in-an-arrayparameter\">Enumerate across the items in an ArrayParameter</h2></div>\n\
<p>Each item in an <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ArrayParameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_array_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ArrayParameter</a></span> is a <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>. To enumerate through this array, do as follows:</p>\n\
<div class=\'codeBlock\'><pre>pa = MaxPlus.ArrayParameter._CastFrom(p)\n\
for v in pa.Items:\n\
</pre></div><p>The following example demonstrates how to get the properties for the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ArrayParameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_array_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ArrayParameter</a></span>, then enumerate across its items and obtain each item&#39;s properties.</p>\n\
<div class=\'codeBlock\'><pre>pa = MaxPlus.ArrayParameter._CastFrom(p)\n\
print &#39;   &#39;, pa.Name, pa.Type, pa.IsObsolete, pa.IsAnimatable, pa.IsReadOnly, pa.IsArrayData, pa.Value\n\
for v in pa.Items:\n\
    print &#39;      &#39;, v.TabIndex, v.Name, v.Type, v.IsObsolete, v.IsAnimatable, v.IsReadOnly, v.IsArrayData, v.Value\n\
</pre></div><div class=\'section\'><a id=\"example\"></a><h2 id=\"example\">Example</h2></div>\n\
<p>The following example creates a material, then enumerates through each <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span> in the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ParameterBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter_block.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ParameterBlock</a></span>. Then, for <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>s where <span class=\'code\'>Parameter.IsArrayData</span> is true, it prints out each value in the array. For <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>s where <span class=\'code\'>Parameter.IsArrayParameter</span> is true, it casts the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span> to an <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ArrayParameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_array_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ArrayParameter</a></span>, then prints out the properties of the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ArrayParameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_array_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ArrayParameter</a></span>. Then, it iterates through each <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span> in the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ArrayParameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_array_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ArrayParameter</a></span> and prints out the properties for each <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Parameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_parameter.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Parameter</a></span>.</p>\n\
<div class=\'codeBlock\'><pre>import MaxPlus\n\
\n\
# Define a method to print array data\n\
def printArrayData(indent, v):\n\
    count = len(v)\n\
    print &#39;%s#(&#39; % indent,\n\
    for i in xrange(count):\n\
        if i != (count-1):\n\
            print &#39;%s, &#39; % str(v[i]),\n\
        else:\n\
            print &#39;%s&#39; % str(v[i]),\n\
    print &#39;)&#39;\n\
\n\
# Create a standard material\n\
obj = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateMaterial\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a68d623b321702ec0ea5031848405cc8c&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Factory.CreateMaterial</a>(MaxPlus.ClassIds.Standardmaterial)\n\
\n\
# Enumerate across Parameters and print out the properties of each Parameter \n\
for p in obj.ParameterBlock.Parameters:  \n\
    print &#39; &#39;, p.Name, p.Type, p.IsObsolete, p.IsAnimatable, p.IsReadOnly, p.IsArrayData, p.Value\n\
\n\
# If IsArrayData is true, then print out the array data\n\
    if p.IsArrayData:  \n\
        v = p.Value\n\
        printArrayData(&#39; &#39;, v)\n\
\n\
# If IsArrayParameter is true, then cast the Parameter to an ArrayParameter\n\
    if p.IsArrayParameter:  \n\
        pa = MaxPlus.ArrayParameter._CastFrom(p)\n\
        #print out the properties of the ArrayParameter\n\
        print &#39; &#39;, pa.Name, pa.Type, pa.IsObsolete, pa.IsAnimatable, pa.IsReadOnly, pa.IsArrayData, pa.NumItems, pa.IsResizable, pa.Value  \n\
\n\
# For each Parameter in each ArrayParameter, print out its properties\n\
        for v in pa:    \n\
            print &#39; &#39;, v.TabIndex, v.Name, v.Type, v.IsObsolete, v.IsAnimatable, v.IsReadOnly, v.IsArrayData, v.Value\n\
</pre></div><div class=\'section\'><a id=\"related-topics\"></a><h2 id=\"related-topics\">Related topics</h2></div>\n\
<ul>\n\
<li><a href=\"#!/url=./developer/executing_maxscript_from_python.html\">Executing MAXScript from Python</a></li>\n\
</ul>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";